if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[sp_AmountbedLoad_folder]') and xtype = N'P')
drop procedure [dbo].[sp_AmountbedLoad_folder]
GO
create procedure dbo.sp_AmountbedLoad_folder @x xml
 ,@FileID uniqueidentifier = null
 ,@Worker uniqueidentifier = null
as
begin

SELECT 
  newid() as [ID]
 ,T.c.value('../HEADER[1]/FILENAME[1]', 'varchar(26)') AS [FILENAME]
 ,T.c.value('../HEADER[1]/MO[1]', 'varchar(6)') AS [MO]
 ,T.c.value('./N_ZAP[1]', 'int') AS [N_ZAP]
 ,T.c.value('./TYPE[1]', 'varchar(6)') AS [TYPE]
 ,T.c.value('./DATE_BEGIN[1]', 'datetime') AS DATE_BEGIN
 ,T.c.value('./DATE_END[1]', 'datetime') AS DATE_END
 ,T.c.value('./BR_CODE[1]', 'varchar(17)') AS BR_CODE
 ,T.c.value('./DIVISION[1]', 'varchar(16)') AS DIVISION
 ,T.c.value('./V020_STRUCTURE_BED[1]', 'int') AS V020_STRUCTURE_BED
 ,T.c.value('./AmountBedID[1]', 'uniqueidentifier') AS AmountBedID--Заглушка
 ,T.c.value('./DivisionID[1]', 'uniqueidentifier') AS DivisionID--Заглушка
 ,T.c.value('./BranchID[1]', 'uniqueidentifier') AS BranchID--Заглушка
INTO #ZAP
FROM @x.nodes('AMOUNT_BED//BODY') T(c)

create table #Errors
(
	CODE int,
	COMMENT varchar(250)
)

insert into #Errors
select 1, 'МО не найдена. N_ZAP('+cast(N_ZAP as varchar)+')'
from #ZAP z
where not exists(select * from iszl.t_f003 lm where lm.mcod = z.MO)

--insert into #Errors
--select 2, 'Профиль койки не найден'
--from #ZAP zap, #ZGLV zglv
--where not exists(select* from iszl.T_V020_STRUCTURE_BED t where t.IDK_PR = zap.V020_STRUCTURE_BED)


-- поиск отделения и филиала
update zap
set AmountBedID = ( select top 1 ab.AmountBedID 
					from iszl.T_AMOUNT_BED ab
						join iszl.T_DIVISION div on div.DivisionID = ab.DivisionObj
						left join iszl.T_BRANCH br on div.Branch = br.BranchID 
					where ab.V020_STRUCTURE_BED = zap.V020_STRUCTURE_BED and div.CODE = zap.DIVISION 
						and (div.LpuMain=zap.MO OR br.F003Mo=zap.MO) )
	,DivisionID = ( select top 1 div.DivisionID 
					from iszl.T_DIVISION div 
						left join iszl.T_BRANCH br on div.Branch = br.BranchID 
					where div.CODE = zap.DIVISION
						and (div.LpuMain=zap.MO OR br.F003Mo=zap.MO) )
	,BranchID = (select top 1 br.BranchID from iszl.T_BRANCH br where br.BR_CODE=zap.BR_CODE and br.F003Mo=zap.MO)
from #ZAP zap

--select * from #ZAP zap
--select* from #Errors
insert into #Errors
select 2, 'Не найдено подразделение ('+BR_CODE+') Для МО ('+ MO +'). N_ZAP('+cast(N_ZAP as varchar)+')'
from #ZAP
where BranchID is null and BR_CODE is not null

insert into #Errors
select 3, 'Не найдено отделение ('+DIVISION+'). Для подразделение ('+ BR_CODE +'). Для МО ('+ MO +'). N_ZAP('+cast(N_ZAP as varchar)+')'
from #ZAP
where DivisionID is null and BranchID is not null



--insert into #Errors
--select 4, 'Не найден профиль койки ('+cast(V020_STRUCTURE_BED as varchar(10))+'). Для отделения ('+DIVISION+'). Для подразделения ('+ BR_CODE +'). Для МО ('+ MO +')'
--from #ZAP
--where AmountBedID is null and BranchID is not null and DivisionID is not null

--DROP TABLE #ZAP
--DROP TABLE #Errors


insert into #Errors (CODE,COMMENT)
select 6, 'Неверный тип операции. N_ZAP('+cast(N_ZAP as varchar)+')'
from #ZAP
where [TYPE]<>'Insert' and [TYPE]<>'Update' and [TYPE]<>'Delete'

--Insert
if((select COUNT(*) from #Errors) = 0)
begin

	-- удаляем, если есть
	delete t from iszl.T_AMOUNT_BED t
	join #ZAP zap on t.AmountBedID = zap.AmountBedID
	where [TYPE]='Insert'

	-- вставка, если нет ошибок
	INSERT INTO [ISZL].[T_AMOUNT_BED]
			   ([AmountBedID]
			   ,[DATE_BEGIN]
			   ,[DATE_END]
			   ,[BR_CODE]
			   ,[DIVISION]
			   ,[V020_STRUCTURE_BED]
			   ,[DivisionObj])
	select
			   ID--(<AmountBedID, uniqueidentifier,>
			   ,zap.DATE_BEGIN--, datetime,>
			   ,zap.DATE_END--, datetime,>
			   ,zap.BR_CODE--, varchar(17),>
			   ,zap.DIVISION--, varchar(16),>
			   ,zap.V020_STRUCTURE_BED--, int,>
			   ,zap.DivisionID--, uniqueidentifier,>)
	from #ZAP zap
	where [TYPE]='Insert'

	IF COL_LENGTH('ISZL.T_AMOUNT_BED', 'FILENAME') IS not NULL
	BEGIN
		update t1
		set t1.[FILENAME] = z.[FILENAME]
		from ISZL.T_AMOUNT_BED t1
		join #ZAP z on z.[ID] = t1.[AmountBedID]
		where [TYPE]='Insert'
	END

end

--Update
if((select COUNT(*) from #Errors) = 0)
begin

	insert into #Errors
	select 4, 'Запись не найдена в ранее загруженных списках'
	from #ZAP zap
	where zap.AmountBedID is null and [TYPE]='Update'

	UPDATE t
	   SET [DATE_BEGIN] = zap.DATE_BEGIN--, datetime,>
		  ,[DATE_END] = zap.DATE_END--, datetime,>
		  ,[BR_CODE] = zap.BR_CODE--, varchar(17),>
		  ,[DIVISION] = zap.DIVISION--, varchar(16),>
		  ,[V020_STRUCTURE_BED] = zap.V020_STRUCTURE_BED--, int,>
		  ,[DivisionObj] = zap.DivisionID--<DivisionObj, uniqueidentifier,>
	from [ISZL].[T_AMOUNT_BED] t, #ZAP zap
	WHERE (select COUNT(*) from #Errors) = 0 and t.AmountBedID = zap.AmountBedID and [TYPE]='Update'

	IF COL_LENGTH('ISZL.T_AMOUNT_BED', 'FILENAME') IS not NULL
	BEGIN
		update t1
		set t1.[FILENAME] = z.[FILENAME]
		from ISZL.T_AMOUNT_BED t1
		join #ZAP z on z.AmountBedID = t1.[AmountBedID]
		where [TYPE]='Update'
	END

end

--Delete
if((select COUNT(*) from #Errors) = 0)
begin

	insert into #Errors
	select 5, 'Запись не найдена в ранее загруженных списках'
	from #ZAP zap
	where zap.AmountBedID is null and [TYPE]='Delete'

	delete t
	from [ISZL].[T_AMOUNT_BED] t, #ZAP zap
	WHERE (select COUNT(*) from #Errors) = 0 and t.AmountBedID = zap.AmountBedID and [TYPE]='Delete'

end

select (case 
	   when (select COUNT(*) from #Errors) = 0 
	   then cast(1 as bit)
	   else case
			when (select COUNT(*) from #Errors) > 0
			then cast(0 as bit)
			end
	   end),
	   '<?xml version="1.0" encoding="Windows-1251"?>' 
		+ 
		(
			SELECT 
				CODE as 'CODE'
				,COMMENT as 'COMMENT'
			FROM #Errors 
			FOR XML PATH('ERR'),ROOT('ROOT')
		)

DROP TABLE #ZAP
DROP TABLE #Errors
end
